/// <reference path="jquery-1.3.2-vsdoc2.js" />

var user = System.Gadget.Settings.read("user");
var pass = System.Gadget.Settings.read("pass");
var bg = System.Gadget.Settings.read("background");

System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClosed;

var connected_interval = 1000 * 60 * 15;
var not_connected_interval = 1000 * 15;
var timer_id = 0;
var data;

$(document).ready(load);

function load()
{
    fetch();
    t2.onclick = showDetails;
    t2.style.cursor = "pointer";
    content.onmousewheel = wheel;
    System.Gadget.Flyout.file = "Details.html";
    if (bg == "") bg = "dark.png";
    System.Gadget.background = bg;

    $("#refresh")
        .click(fetch)
        .hover(function() { $(this).attr("src", "refresh_hover.png"); },
               function() { $(this).attr("src", "refresh_normal.png"); });
}

function setTimer(time)
{
    clearTimeout(timer_id);
    timer_id = setTimeout("fetch()", time);
}

function fetch()
{
    try
    {
        if (user == "" || pass == "")
        {
            message("no account set");
            return;
        }

        message("AdSensor");
        setTimer(connected_interval);

        message("Updating...");
        httpGet("https://www.google.com/accounts/ServiceLoginAuth?service=adsense&hl=en-US&ltmpl=login&ifr=true&passive=true&rm=hide&nui=3&alwf=true&continue=https%3A%2F%2Fwww.google.com%2Fadsense%2Fgaiaauth&followup=https%3A%2F%2Fwww.google.com%2Fadsense%2Fgaiaauth", processStage1);
        information("Requesting login page");
    }
    catch (e)
    {
        restart();
    }
}

function processStage1(response)
{
    try
    {
        var re = /<input type="hidden" name="(.*?)" value="(.*?)">/ig;
        var match = re.exec(response);
        var post_data = '';

        if (!match)
        {
            message("Offline");
            setTimer(not_connected_interval);
            return;
        }
        else
        {
            information("Got login page (stage 1)");
            
            while (match)
            {
                post_data = post_data + match[1] + '=' + Url.encode(match[2]) + '&';
                match = re.exec(response);
            }

            post_data = post_data + 'Email=' + Url.encode(user) + '&Passwd=' + Url.encode(pass) + '&null=Sign+in';
            var querystring = "https://www.google.com/accounts/ServiceLoginAuth?" + post_data;
            httpGet(querystring, processStage2);
            information("Posting credentials (stage 1)");
        }
    }
    catch (e)
    {
        restart();
    }
}

function processStage2(response)
{
    try
    {
        var re = /var url = ('|")(.*?)\1;/i;
        var match = re.exec(response);
        if (match)
        {
            information("Got javascript redirect (stage 2)");
            var querystring = hex_unencode(match[2]);
            httpGet(querystring, processStage3);
            information("Following javascript redirect (stage 2)");
        }
        else
        {
            error("Failed to fetch javascript redirect (stage 2)");
            message("Login Failed");
        }
    }
    catch (e)
    {
        restart();
    }    
}

function processStage3(response)
{
    try
    {
        information("Logged in (stage 3)");
        var querystring = "https://www.google.com/adsense/report/aggregate?product=afc&dateRange.dateRangeType=simple&dateRange.simpleDate=thismonth&reportType=property&groupByPref=date&outputFormat=TSV_EXCEL&unitPref=page";
        httpGet(querystring + "&" + Math.random(), processStage4);
        information("Requesting CSV report data (stage 3)");
    }
    catch (e)
    {
        restart();
    }    
}

function processStage4(response)
{
    try
    {
        if (response.match(/Date/))
        {
            data = response.split("\n");

            showStats(new Stats(data[data.length - 4]), "t"); // today
            showStats(new Stats(data[data.length - 2]), "a"); // average

            if (data.length > 5)
                showStats(new Stats(data[data.length - 5]), "y"); // yesterday

            var totals = new Stats(data[data.length - 3]);
            $(t1).html(totals.clicks + "<br/>" + totals.impressions);
            $(t2).text("$" + totals.earnings);
            message("AdSensor");
        }
        else
        {
            error("Failed to fetch CSV report data (stage 4)");
            message("CSV Request Failed");
        }
    }
    catch (e)
    {
        restart();
    }
}

function httpGet(query, callback)
{
    httpRequest("GET", query, callback);
}

function httpPost(query, callback, data)
{
    httpRequest("POST", query, callback, data);
}

function httpRequest(action, query, callback, data)
{
    $.ajax(
    {
        type: action,
        url: query,
        success: callback,
        data: data,
        error: function() { restart(); }
    });
}

function restart()
{
    message("AdSensor");
    setTimer(not_connected_interval);
}

function Stats(row)
{
    var data = row.split("\t");
    this.date = removeQuotes(data[0])
    this.impressions = removeQuotes(data[1]);
    this.clicks = removeQuotes(data[2]);
    this.ctr = removeQuotes(data[3]);
    this.ecpm = removeQuotes(data[4]);
    this.earnings = removeQuotes(data[5]);
}

function removeQuotes(item)
{
    return item.replace(/"/g, "");
}

function showStats(stats, prefix)
{
    $("#" + prefix + "_earnings").text(stats.earnings);
    $("#" + prefix + "_clicks").text(stats.clicks);
    $("#" + prefix + "_impressions").text(stats.impressions);
    $("#" + prefix + "_ctr").text(stats.ctr);
    $("#" + prefix + "_ecpm").text("$" + stats.ecpm);
}

function showDetails()
{
    if (System.Gadget.Flyout.show == false)
    {
        System.Gadget.Flyout.onShow = onShowDetailsFlyout;
        System.Gadget.Flyout.show = true;
    }
    else
    {
        System.Gadget.Flyout.show = false;
    }
}

function onShowDetailsFlyout()
{
    var table = System.Gadget.Flyout.document.getElementById("dataTable");

    for (var i = 1; i <= 32; i++)
    {
        try
        {
            if (i < data.length - 3)
            {
                var stats = new Stats(data[i]);
                stats.date = stats.date.substr(5);
                updateRow(table.insertRow(i), stats);
            }
            else
            {
                table.insertRow(i).insertCell(0).innerHTML = "&nbsp;";
            }
        }
        catch (e)
        {
        }
    }

    var average = new Stats(data[data.length - 2]);
    average.date = "Avg";
    updateRow(table.insertRow(33), average);

    var totals = new Stats(data[data.length - 3]);
    totals.date = "Totals";
    updateRow(table.insertRow(34), totals);
}

function updateRow(row, stats)
{
    row.insertCell(0).innerHTML = stats.date;
    row.insertCell(1).innerHTML = stats.clicks;
    row.insertCell(2).innerHTML = stats.impressions;
    row.insertCell(3).innerHTML = stats.ctr;
    row.insertCell(4).innerHTML = stats.ecpm;
    row.insertCell(5).innerHTML = stats.earnings;
}

// Helper functions

function hex_unencode(sStr)
{
    var qs = sStr;
    var unicode_re = /\\x([\da-f|A-F]{2})/ig;
    var unicode_match = unicode_re.exec(sStr);
    while (unicode_match)
    {
        var unescaped_char = unescape('%' + unicode_match[1]);
        var match_re = new RegExp();
        match_re.compile('\\\\x' + unicode_match[1], 'i');
        qs = qs.replace(match_re, unescaped_char);
        unicode_match = unicode_re.exec(sStr);
    }
    return (qs);
}

function settingsClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
        user = System.Gadget.Settings.read("user");
        pass = System.Gadget.Settings.read("pass");
        fetch();
    }
}

function wheel()
{
    var delta = 0;

    if (window.event.wheelDelta)
    {
        delta = window.event.wheelDelta / 120;
    }
    
    if (delta != 0)
    {
        var colors = ['black.png', 'dark.png', 'gray.png', 'green.png', 'blue.png'];
        for (var i = 0; i < colors.length; ++i)
        {
            if (System.Gadget.background == colors[i])
            {
                background = colors[(delta > 0 ? ++i : --i + colors.length) % colors.length];
                System.Gadget.Settings.writeString("background", background);
                System.Gadget.background = background;
                break;
            }
        }
    }
}

function information(msg)
{
    //eventLog("Adsensor information: " + msg);
}

function error(msg)
{
    eventLog("Adsensor error: " + msg);
}

function eventLog(msg)
{
    System.Diagnostics.EventLog.writeEntry(msg);
}

function message(text)
{
    $(msg).text(text);
}

var Url = {

    // public method for url encoding
    encode: function(string)
    {
        return escape(this._utf8_encode(string));
    },

    // public method for url decoding
    decode: function(string)
    {
        return this._utf8_decode(unescape(string));
    },

    // private method for UTF-8 encoding
    _utf8_encode: function(string)
    {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++)
        {
            var c = string.charCodeAt(n);

            if (c < 128)
            {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048))
            {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else
            {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode: function(utftext)
    {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length)
        {

            c = utftext.charCodeAt(i);

            if (c < 128)
            {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224))
            {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else
            {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }

        return string;
    }
}